'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formsyReact = require('formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propUtilities = require('./propUtilities');

var TimeInput = _react2.default.createClass({
  displayName: 'TimeInput',


  mixins: [_formsyReact2.default.Mixin, _mixins2.default],

  getInitialState: function getInitialState() {
    return {
      lastVal: ''
    };
  },
  internalValidation: function internalValidation(val) {

    var isValid = true,
        charArray = val.split(':').join('').split(''),
        regexp = /^\d{0,2}?\:?\d{0,2}$/,
        valArr = [];

    if (!regexp.test(val)) {
      isValid = false;
    }

    // check each character
    if (charArray[0] && (parseInt(charArray[0], 10) < 0 || parseInt(charArray[0], 10) > 2)) {
      isValid = false;
    }

    if (charArray[2] && (parseInt(charArray[2], 10) < 0 || parseInt(charArray[2], 10) > 5)) {
      isValid = false;
    }

    if (valArr.indexOf(':')) {
      valArr = val.split(':');
    } else {
      valArr.push(val);
    }

    // check mm and HH
    if (valArr[0] && valArr[0].length && (parseInt(valArr[0], 10) < 0 || parseInt(valArr[0], 10) > 23)) {
      isValid = false;
    }

    if (valArr[1] && valArr[1].length && (parseInt(valArr[1], 10) < 0 || parseInt(valArr[1], 10) > 59)) {
      isValid = false;
    }

    return isValid;
  },


  changeValue: function changeValue(value) {
    if (value === this.getValue()) {
      return;
    }

    if (this.internalValidation(value)) {
      if (value.length === 2 && this.state.lastVal.length !== 3) {
        value = value + ':';
      }

      if (value.length === 2 && this.state.lastVal.length === 3) {
        value = value.slice(0, 1);
      }

      if (value.length > 5) {
        return false;
      }

      this.setState({ lastVal: value });

      this.setValue(value);

      if (value.length === 5) {
        // Eventually add a next focus event
      }
    }
  },

  renderElement: function renderElement() {
    var _this = this;

    return _react2.default.createElement(_reactBootstrap.FormControl, {
      disabled: this.props.disabled,
      onChange: function onChange(e) {
        return _this.changeValue(e.target.value);
      },
      ref: function ref(c) {
        return _this.element = c;
      },
      type: 'tel',
      value: this.getValue()
    });
  },

  render: function render() {
    if (this.props.type === 'hidden' || this.props.elementOnly) {
      return this.renderElement();
    }

    var Layout = this.getLayout();
    return _react2.default.createElement(Layout.TimeInput, { element: this });
  }
});

module.exports = TimeInput;